/* GtkSettings.c generated by valac 0.56.2, the Vala compiler
 * generated from GtkSettings.vala, do not modify */

/*
 * Copyright (C) Elementary Tweaks Developers, 2014 - 2020
 *               Pantheon Tweaks Developers, 2020 - 2022
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "pantheon-tweaks.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gstdio.h>

enum  {
	PANTHEON_TWEAKS_GTK_SETTINGS_0_PROPERTY,
	PANTHEON_TWEAKS_GTK_SETTINGS_PREFER_DARK_THEME_PROPERTY,
	PANTHEON_TWEAKS_GTK_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* pantheon_tweaks_gtk_settings_properties[PANTHEON_TWEAKS_GTK_SETTINGS_NUM_PROPERTIES];
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PantheonTweaksGtkSettingsPrivate {
	GKeyFile* keyfile;
	gchar* path;
};

static gint PantheonTweaksGtkSettings_private_offset;
static gpointer pantheon_tweaks_gtk_settings_parent_class = NULL;

static gint pantheon_tweaks_gtk_settings_get_integer (PantheonTweaksGtkSettings* self,
                                               const gchar* key);
static void pantheon_tweaks_gtk_settings_set_integer (PantheonTweaksGtkSettings* self,
                                               const gchar* key,
                                               gint val);
static void pantheon_tweaks_gtk_settings_save_keyfile (PantheonTweaksGtkSettings* self);
static void pantheon_tweaks_gtk_settings_finalize (GObject * obj);
static GType pantheon_tweaks_gtk_settings_get_type_once (void);
static void _vala_pantheon_tweaks_gtk_settings_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_pantheon_tweaks_gtk_settings_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);

static inline gpointer
pantheon_tweaks_gtk_settings_get_instance_private (PantheonTweaksGtkSettings* self)
{
	return G_STRUCT_MEMBER_P (self, PantheonTweaksGtkSettings_private_offset);
}

PantheonTweaksGtkSettings*
pantheon_tweaks_gtk_settings_construct (GType object_type)
{
	PantheonTweaksGtkSettings * self = NULL;
	GKeyFile* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	gboolean _tmp6_;
	GError* _inner_error0_ = NULL;
	self = (PantheonTweaksGtkSettings*) g_object_new (object_type, NULL);
	_tmp0_ = g_key_file_new ();
	_g_key_file_unref0 (self->priv->keyfile);
	self->priv->keyfile = _tmp0_;
	_tmp1_ = g_get_user_config_dir ();
	_tmp2_ = g_strconcat (_tmp1_, "/gtk-3.0/settings.ini", NULL);
	_g_free0 (self->priv->path);
	self->priv->path = _tmp2_;
	_tmp3_ = self->priv->path;
	_tmp4_ = g_file_new_for_path (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = !g_file_query_exists (_tmp5_, NULL);
	_g_object_unref0 (_tmp5_);
	if (_tmp6_) {
		return self;
	}
	{
		GKeyFile* _tmp7_;
		const gchar* _tmp8_;
		_tmp7_ = self->priv->keyfile;
		_tmp8_ = self->priv->path;
		g_key_file_load_from_file (_tmp7_, _tmp8_, 0, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		_tmp11_ = g_strconcat ("Error loading GTK+ Keyfile settings.ini: ", _tmp10_, NULL);
		_tmp12_ = _tmp11_;
		g_warning ("GtkSettings.vala:53: %s", _tmp12_);
		_g_free0 (_tmp12_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	return self;
}

PantheonTweaksGtkSettings*
pantheon_tweaks_gtk_settings_new (void)
{
	return pantheon_tweaks_gtk_settings_construct (PANTHEON_TWEAKS_TYPE_GTK_SETTINGS);
}

/**
     * Gets an integer from the keyfile at Settings group
     */
static gint
pantheon_tweaks_gtk_settings_get_integer (PantheonTweaksGtkSettings* self,
                                          const gchar* key)
{
	gint key_int = 0;
	GError* _inner_error0_ = NULL;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (key != NULL, 0);
	key_int = 0;
	{
		gint _tmp0_ = 0;
		GKeyFile* _tmp1_;
		_tmp1_ = self->priv->keyfile;
		_tmp0_ = g_key_file_get_integer (_tmp1_, "Settings", key, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		key_int = _tmp0_;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp2_ = e;
		_tmp3_ = _tmp2_->message;
		_tmp4_ = g_strconcat ("Error getting GTK+ int setting: ", _tmp3_, NULL);
		_tmp5_ = _tmp4_;
		g_warning ("GtkSettings.vala:66: %s", _tmp5_);
		_g_free0 (_tmp5_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp6_ = -1;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp6_;
	}
	result = key_int;
	return result;
}

/**
     * Sets an integer from the keyfile at Settings group
     */
static void
pantheon_tweaks_gtk_settings_set_integer (PantheonTweaksGtkSettings* self,
                                          const gchar* key,
                                          gint val)
{
	GKeyFile* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = self->priv->keyfile;
	g_key_file_set_integer (_tmp0_, "Settings", key, val);
	pantheon_tweaks_gtk_settings_save_keyfile (self);
}

/**
     * Saves the keyfile to disk
     */
static void
pantheon_tweaks_gtk_settings_save_keyfile (PantheonTweaksGtkSettings* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		gchar* data = NULL;
		GKeyFile* _tmp0_;
		gchar* _tmp1_;
		const gchar* _tmp2_;
		_tmp0_ = self->priv->keyfile;
		_tmp1_ = g_key_file_to_data (_tmp0_, NULL, NULL);
		data = _tmp1_;
		_tmp2_ = self->priv->path;
		g_file_set_contents (_tmp2_, data, (gssize) -1, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (data);
			if (_inner_error0_->domain == G_FILE_ERROR) {
				goto __catch0_g_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_g_free0 (data);
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		_tmp5_ = g_strconcat ("Error saving GTK+ Keyfile settings.ini: ", _tmp4_, NULL);
		_tmp6_ = _tmp5_;
		g_warning ("GtkSettings.vala:89: %s", _tmp6_);
		_g_free0 (_tmp6_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

gboolean
pantheon_tweaks_gtk_settings_get_prefer_dark_theme (PantheonTweaksGtkSettings* self)
{
	gboolean result;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gboolean _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->path;
	_tmp1_ = g_file_new_for_path (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = !g_file_query_exists (_tmp2_, NULL);
	_g_object_unref0 (_tmp2_);
	if (_tmp3_) {
		result = FALSE;
		return result;
	}
	result = pantheon_tweaks_gtk_settings_get_integer (self, "gtk-application-prefer-dark-theme") == 1;
	return result;
}

void
pantheon_tweaks_gtk_settings_set_prefer_dark_theme (PantheonTweaksGtkSettings* self,
                                                    gboolean value)
{
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	if (value) {
		_tmp0_ = 1;
	} else {
		_tmp0_ = 0;
	}
	pantheon_tweaks_gtk_settings_set_integer (self, "gtk-application-prefer-dark-theme", _tmp0_);
	g_object_notify_by_pspec ((GObject *) self, pantheon_tweaks_gtk_settings_properties[PANTHEON_TWEAKS_GTK_SETTINGS_PREFER_DARK_THEME_PROPERTY]);
}

static void
pantheon_tweaks_gtk_settings_class_init (PantheonTweaksGtkSettingsClass * klass,
                                         gpointer klass_data)
{
	pantheon_tweaks_gtk_settings_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PantheonTweaksGtkSettings_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_pantheon_tweaks_gtk_settings_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_pantheon_tweaks_gtk_settings_set_property;
	G_OBJECT_CLASS (klass)->finalize = pantheon_tweaks_gtk_settings_finalize;
	/**
	     * GTK should prefer the dark theme or not
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), PANTHEON_TWEAKS_GTK_SETTINGS_PREFER_DARK_THEME_PROPERTY, pantheon_tweaks_gtk_settings_properties[PANTHEON_TWEAKS_GTK_SETTINGS_PREFER_DARK_THEME_PROPERTY] = g_param_spec_boolean ("prefer-dark-theme", "prefer-dark-theme", "prefer-dark-theme", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
pantheon_tweaks_gtk_settings_instance_init (PantheonTweaksGtkSettings * self,
                                            gpointer klass)
{
	self->priv = pantheon_tweaks_gtk_settings_get_instance_private (self);
}

static void
pantheon_tweaks_gtk_settings_finalize (GObject * obj)
{
	PantheonTweaksGtkSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PANTHEON_TWEAKS_TYPE_GTK_SETTINGS, PantheonTweaksGtkSettings);
	_g_key_file_unref0 (self->priv->keyfile);
	_g_free0 (self->priv->path);
	G_OBJECT_CLASS (pantheon_tweaks_gtk_settings_parent_class)->finalize (obj);
}

/**
 * Settings for Gtk; thanks gnome-tweak-tool for the help!
 */
static GType
pantheon_tweaks_gtk_settings_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PantheonTweaksGtkSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pantheon_tweaks_gtk_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PantheonTweaksGtkSettings), 0, (GInstanceInitFunc) pantheon_tweaks_gtk_settings_instance_init, NULL };
	GType pantheon_tweaks_gtk_settings_type_id;
	pantheon_tweaks_gtk_settings_type_id = g_type_register_static (G_TYPE_OBJECT, "PantheonTweaksGtkSettings", &g_define_type_info, 0);
	PantheonTweaksGtkSettings_private_offset = g_type_add_instance_private (pantheon_tweaks_gtk_settings_type_id, sizeof (PantheonTweaksGtkSettingsPrivate));
	return pantheon_tweaks_gtk_settings_type_id;
}

GType
pantheon_tweaks_gtk_settings_get_type (void)
{
	static volatile gsize pantheon_tweaks_gtk_settings_type_id__once = 0;
	if (g_once_init_enter (&pantheon_tweaks_gtk_settings_type_id__once)) {
		GType pantheon_tweaks_gtk_settings_type_id;
		pantheon_tweaks_gtk_settings_type_id = pantheon_tweaks_gtk_settings_get_type_once ();
		g_once_init_leave (&pantheon_tweaks_gtk_settings_type_id__once, pantheon_tweaks_gtk_settings_type_id);
	}
	return pantheon_tweaks_gtk_settings_type_id__once;
}

static void
_vala_pantheon_tweaks_gtk_settings_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	PantheonTweaksGtkSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PANTHEON_TWEAKS_TYPE_GTK_SETTINGS, PantheonTweaksGtkSettings);
	switch (property_id) {
		case PANTHEON_TWEAKS_GTK_SETTINGS_PREFER_DARK_THEME_PROPERTY:
		g_value_set_boolean (value, pantheon_tweaks_gtk_settings_get_prefer_dark_theme (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_pantheon_tweaks_gtk_settings_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	PantheonTweaksGtkSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PANTHEON_TWEAKS_TYPE_GTK_SETTINGS, PantheonTweaksGtkSettings);
	switch (property_id) {
		case PANTHEON_TWEAKS_GTK_SETTINGS_PREFER_DARK_THEME_PROPERTY:
		pantheon_tweaks_gtk_settings_set_prefer_dark_theme (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

