/* XSettings.c generated by valac 0.56.2, the Vala compiler
 * generated from XSettings.vala, do not modify */

/*
 * Copyright (C) Elementary Tweaks Developers, 2014 - 2020
 *               Pantheon Tweaks Developers, 2020 - 2022
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "pantheon-tweaks.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_dict_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_dict_unref (var), NULL)))
typedef struct _PantheonTweaksParamSpecXSettings PantheonTweaksParamSpecXSettings;

struct _PantheonTweaksXSettingsPrivate {
	GSettings* settings;
};

struct _PantheonTweaksParamSpecXSettings {
	GParamSpec parent_instance;
};

static gint PantheonTweaksXSettings_private_offset;
static gpointer pantheon_tweaks_xsettings_parent_class = NULL;

static void pantheon_tweaks_xsettings_finalize (PantheonTweaksXSettings * obj);
static GType pantheon_tweaks_xsettings_get_type_once (void);

static inline gpointer
pantheon_tweaks_xsettings_get_instance_private (PantheonTweaksXSettings* self)
{
	return G_STRUCT_MEMBER_P (self, PantheonTweaksXSettings_private_offset);
}

PantheonTweaksXSettings*
pantheon_tweaks_xsettings_construct (GType object_type)
{
	PantheonTweaksXSettings* self = NULL;
	GSettings* _tmp0_;
	self = (PantheonTweaksXSettings*) g_type_create_instance (object_type);
	_tmp0_ = g_settings_new ("org.gnome.settings-daemon.plugins.xsettings");
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	return self;
}

PantheonTweaksXSettings*
pantheon_tweaks_xsettings_new (void)
{
	return pantheon_tweaks_xsettings_construct (PANTHEON_TWEAKS_TYPE_XSETTINGS);
}

void
pantheon_tweaks_xsettings_reset (PantheonTweaksXSettings* self)
{
	GSettings* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	g_settings_reset (_tmp0_, "overrides");
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

gboolean
pantheon_tweaks_xsettings_has_gnome_menu (PantheonTweaksXSettings* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = pantheon_tweaks_xsettings_get_decoration_layout (self);
	_tmp1_ = _tmp0_;
	result = string_contains (_tmp1_, "menu");
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

void
pantheon_tweaks_xsettings_set_gnome_menu (PantheonTweaksXSettings* self,
                                          gboolean set,
                                          const gchar* new_layout)
{
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (new_layout != NULL);
	if (set) {
		gchar* _tmp0_;
		gchar* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		_tmp0_ = g_strconcat (new_layout, ",menu", NULL);
		_tmp1_ = _tmp0_;
		pantheon_tweaks_xsettings_set_decoration_layout (self, _tmp1_);
		_g_free0 (_tmp1_);
		_tmp2_ = pantheon_tweaks_xsettings_get_decoration_layout (self);
		_tmp3_ = _tmp2_;
		if (string_contains (_tmp3_, ":,")) {
			const gchar* _tmp4_;
			const gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			_tmp4_ = pantheon_tweaks_xsettings_get_decoration_layout (self);
			_tmp5_ = _tmp4_;
			_tmp6_ = string_replace (_tmp5_, ":,", ":");
			_tmp7_ = _tmp6_;
			pantheon_tweaks_xsettings_set_decoration_layout (self, _tmp7_);
			_g_free0 (_tmp7_);
		} else {
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			_tmp8_ = pantheon_tweaks_xsettings_get_decoration_layout (self);
			_tmp9_ = _tmp8_;
			if (!string_contains (_tmp9_, ":")) {
				gchar* _tmp10_;
				gchar* _tmp11_;
				_tmp10_ = g_strconcat (new_layout, ":menu", NULL);
				_tmp11_ = _tmp10_;
				pantheon_tweaks_xsettings_set_decoration_layout (self, _tmp11_);
				_g_free0 (_tmp11_);
			}
		}
	} else {
		pantheon_tweaks_xsettings_set_decoration_layout (self, new_layout);
	}
	_tmp12_ = pantheon_tweaks_xsettings_get_decoration_layout (self);
	_tmp13_ = _tmp12_;
	g_debug ("XSettings.vala:71: XSettings: %s\n", _tmp13_);
}

const gchar*
pantheon_tweaks_xsettings_get_decoration_layout (PantheonTweaksXSettings* self)
{
	const gchar* result;
	GVariant* overrides = NULL;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* layout = NULL;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_value (_tmp0_, "overrides");
	overrides = _tmp1_;
	_tmp2_ = overrides;
	_tmp3_ = G_VARIANT_TYPE_STRING;
	_tmp4_ = g_variant_lookup_value (_tmp2_, "Gtk/DecorationLayout", _tmp3_);
	layout = _tmp4_;
	_tmp5_ = layout;
	if (_tmp5_ != NULL) {
		GVariant* _tmp6_;
		const gchar* _tmp7_;
		_tmp6_ = layout;
		_tmp7_ = g_variant_get_string (_tmp6_, NULL);
		result = _tmp7_;
		_g_variant_unref0 (layout);
		_g_variant_unref0 (overrides);
		return result;
	} else {
		result = "";
		_g_variant_unref0 (layout);
		_g_variant_unref0 (overrides);
		return result;
	}
}

void
pantheon_tweaks_xsettings_set_decoration_layout (PantheonTweaksXSettings* self,
                                                 const gchar* value)
{
	GVariant* overrides = NULL;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariantDict* dict = NULL;
	GVariant* _tmp2_;
	GVariantDict* _tmp3_;
	GVariantDict* _tmp4_;
	GVariant* _tmp5_;
	GVariant* _tmp6_;
	GSettings* _tmp7_;
	GVariantDict* _tmp8_;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, "") == 0) {
		return;
	}
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_value (_tmp0_, "overrides");
	overrides = _tmp1_;
	_tmp2_ = overrides;
	_tmp3_ = g_variant_dict_new (_tmp2_);
	dict = _tmp3_;
	_tmp4_ = dict;
	_tmp5_ = g_variant_new_string (value);
	g_variant_ref_sink (_tmp5_);
	_tmp6_ = _tmp5_;
	g_variant_dict_insert_value (_tmp4_, "Gtk/DecorationLayout", _tmp6_);
	_g_variant_unref0 (_tmp6_);
	_tmp7_ = self->priv->settings;
	_tmp8_ = dict;
	_tmp9_ = g_variant_dict_end (_tmp8_);
	g_variant_ref_sink (_tmp9_);
	_tmp10_ = _tmp9_;
	g_settings_set_value (_tmp7_, "overrides", _tmp10_);
	_g_variant_unref0 (_tmp10_);
	_g_variant_dict_unref0 (dict);
	_g_variant_unref0 (overrides);
}

static void
pantheon_tweaks_value_xsettings_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
pantheon_tweaks_value_xsettings_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		pantheon_tweaks_xsettings_unref (value->data[0].v_pointer);
	}
}

static void
pantheon_tweaks_value_xsettings_copy_value (const GValue* src_value,
                                            GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = pantheon_tweaks_xsettings_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
pantheon_tweaks_value_xsettings_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
pantheon_tweaks_value_xsettings_collect_value (GValue* value,
                                               guint n_collect_values,
                                               GTypeCValue* collect_values,
                                               guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		PantheonTweaksXSettings * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = pantheon_tweaks_xsettings_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
pantheon_tweaks_value_xsettings_lcopy_value (const GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
	PantheonTweaksXSettings ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = pantheon_tweaks_xsettings_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
pantheon_tweaks_param_spec_xsettings (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags)
{
	PantheonTweaksParamSpecXSettings* spec;
	g_return_val_if_fail (g_type_is_a (object_type, PANTHEON_TWEAKS_TYPE_XSETTINGS), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
pantheon_tweaks_value_get_xsettings (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PANTHEON_TWEAKS_TYPE_XSETTINGS), NULL);
	return value->data[0].v_pointer;
}

void
pantheon_tweaks_value_set_xsettings (GValue* value,
                                     gpointer v_object)
{
	PantheonTweaksXSettings * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PANTHEON_TWEAKS_TYPE_XSETTINGS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PANTHEON_TWEAKS_TYPE_XSETTINGS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		pantheon_tweaks_xsettings_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		pantheon_tweaks_xsettings_unref (old);
	}
}

void
pantheon_tweaks_value_take_xsettings (GValue* value,
                                      gpointer v_object)
{
	PantheonTweaksXSettings * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PANTHEON_TWEAKS_TYPE_XSETTINGS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PANTHEON_TWEAKS_TYPE_XSETTINGS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		pantheon_tweaks_xsettings_unref (old);
	}
}

static void
pantheon_tweaks_xsettings_class_init (PantheonTweaksXSettingsClass * klass,
                                      gpointer klass_data)
{
	pantheon_tweaks_xsettings_parent_class = g_type_class_peek_parent (klass);
	((PantheonTweaksXSettingsClass *) klass)->finalize = pantheon_tweaks_xsettings_finalize;
	g_type_class_adjust_private_offset (klass, &PantheonTweaksXSettings_private_offset);
}

static void
pantheon_tweaks_xsettings_instance_init (PantheonTweaksXSettings * self,
                                         gpointer klass)
{
	self->priv = pantheon_tweaks_xsettings_get_instance_private (self);
	self->ref_count = 1;
}

static void
pantheon_tweaks_xsettings_finalize (PantheonTweaksXSettings * obj)
{
	PantheonTweaksXSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PANTHEON_TWEAKS_TYPE_XSETTINGS, PantheonTweaksXSettings);
	g_signal_handlers_destroy (self);
	_g_object_unref0 (self->priv->settings);
}

static GType
pantheon_tweaks_xsettings_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { pantheon_tweaks_value_xsettings_init, pantheon_tweaks_value_xsettings_free_value, pantheon_tweaks_value_xsettings_copy_value, pantheon_tweaks_value_xsettings_peek_pointer, "p", pantheon_tweaks_value_xsettings_collect_value, "p", pantheon_tweaks_value_xsettings_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PantheonTweaksXSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pantheon_tweaks_xsettings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PantheonTweaksXSettings), 0, (GInstanceInitFunc) pantheon_tweaks_xsettings_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType pantheon_tweaks_xsettings_type_id;
	pantheon_tweaks_xsettings_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PantheonTweaksXSettings", &g_define_type_info, &g_define_type_fundamental_info, 0);
	PantheonTweaksXSettings_private_offset = g_type_add_instance_private (pantheon_tweaks_xsettings_type_id, sizeof (PantheonTweaksXSettingsPrivate));
	return pantheon_tweaks_xsettings_type_id;
}

GType
pantheon_tweaks_xsettings_get_type (void)
{
	static volatile gsize pantheon_tweaks_xsettings_type_id__once = 0;
	if (g_once_init_enter (&pantheon_tweaks_xsettings_type_id__once)) {
		GType pantheon_tweaks_xsettings_type_id;
		pantheon_tweaks_xsettings_type_id = pantheon_tweaks_xsettings_get_type_once ();
		g_once_init_leave (&pantheon_tweaks_xsettings_type_id__once, pantheon_tweaks_xsettings_type_id);
	}
	return pantheon_tweaks_xsettings_type_id__once;
}

gpointer
pantheon_tweaks_xsettings_ref (gpointer instance)
{
	PantheonTweaksXSettings * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
pantheon_tweaks_xsettings_unref (gpointer instance)
{
	PantheonTweaksXSettings * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PANTHEON_TWEAKS_XSETTINGS_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

